aboutsummaryrefslogtreecommitdiff
path: root/development
diff options
context:
space:
mode:
authorJuan M. Lasca <juanmlasca@gmail.com>2024-02-07 06:34:35 +0700
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2024-02-10 16:09:46 +0700
commitef19e20224b065de8fe9edb54e0e2bbe877b3d4c (patch)
treedf2b1a09fae365d00df3a82ce6ff86b246419906 /development
parent2b2efdaadd284c7fb250f454e797d5b51911c27c (diff)
downloadslackbuilds-ef19e20224b065de8fe9edb54e0e2bbe877b3d4c.tar.xz
development/cosmocc: Added (C library).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/cosmocc/README39
-rw-r--r--development/cosmocc/cosmocc.SlackBuild95
-rw-r--r--development/cosmocc/cosmocc.info10
-rw-r--r--development/cosmocc/scripts/register_ape.sh5
-rw-r--r--development/cosmocc/scripts/unregister_ape.sh5
-rw-r--r--development/cosmocc/slack-desc19
6 files changed, 173 insertions, 0 deletions
diff --git a/development/cosmocc/README b/development/cosmocc/README
new file mode 100644
index 000000000000..a8557c1f29f3
--- /dev/null
+++ b/development/cosmocc/README
@@ -0,0 +1,39 @@
+cosmocc is a precompiled version of GCC that produces polyglot
+executables for the x86_64 / aarch64 architecture using the
+Cosmopolitan libc.
+
+Cosmopolitan Libc makes C a build-once run-anywhere language, like Java,
+except it doesn't need an interpreter or virtual machine. Instead, it
+reconfigures stock GCC and Clang to output a POSIX-approved polyglot
+format that runs natively on many operating systems with the best
+possible performance and a tiny footprint.
+
+======= Support Vector =======
+Platform | Min Version | Circa
+==============================
+AMD | K8 Venus | 2005
+Intel | Core | 2006
+Linux | 2.6.18 | 2007
+Windows | 8 | 2012
+Mac OS X | 15.6 | 2018
+OpenBSD | 7 | 2021
+FreeBSD | 13 | 2020
+NetBSD | 9.2 | 2021
+==============================
+
+NOTES:
+* on calling APE programs:
+ upto zsh version 5.9, it's required to call APE programs
+ this way:
+ sh -c ./APE-program
+ The same case is for Python's subprocess, old versions of fish, etc.
+* on reproducible builds:
+ The cosmocc compiler is designed to generate deterministic output
+ across platforms. Please note that users who need reproducible
+ builds may also want to look into explicitly defining environment
+ variables like `LC_ALL=C` and `SOURCE_DATE_EPOCH=0`, in addition to
+ undefining macros such as `-U__DATE__` and `-U__TIME__`.
+* on (un)registering APE with binfmt_misc:
+ two simple scripts are included in case you want to register or
+ unregister the APE loader with the binfmt_misc kernel facility.
+ You may find them in the /opt/cosmocc/scripts/ directory.
diff --git a/development/cosmocc/cosmocc.SlackBuild b/development/cosmocc/cosmocc.SlackBuild
new file mode 100644
index 000000000000..44b9a53c0fc4
--- /dev/null
+++ b/development/cosmocc/cosmocc.SlackBuild
@@ -0,0 +1,95 @@
+#!/bin/bash
+
+# Slackware build script for cosmocc
+
+# Copyright 2024 Juan M. Lasca <juanmlasca@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=cosmocc
+VERSION=${VERSION:-3.2.4}
+BUILD=${BUILD:-2}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+mkdir $PRGNAM-$VERSION
+cd $PRGNAM-$VERSION
+unzip $CWD/$PRGNAM-$VERSION.zip
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+
+mkdir -p $PKG/opt/$PRGNAM $PKG/usr/bin;
+cp -a $CWD/scripts/ $PKG/opt/$PRGNAM; # see NOTES on README
+
+for i in bin include x86_64-linux-cosmo aarch64-linux-cosmo libexec; do
+ mv $i $PKG/opt/$PRGNAM;
+done
+
+$(cd $PKG/usr/bin/;
+ for i in mktemper march-native zipcopy apelink cosmocross cosmoar \
+ assimilate zipobj cosmoaddr2line cosmocc mkdeps cosmoc++ \
+ cosmoinstall pecheck; do
+ ln -s ../../opt/$PRGNAM/bin/$i $i;
+ done;);
+
+# remove empty directories:
+rmdir $PKG/opt/cosmocc/libexec/gcc/{x86_64,aarch64}-linux-cosmo/11.2.0/install-tools
+
+xz -9 LICENSE.*gpl[23];
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE.*gpl[23].xz README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/cosmocc/cosmocc.info b/development/cosmocc/cosmocc.info
new file mode 100644
index 000000000000..2a560bdac499
--- /dev/null
+++ b/development/cosmocc/cosmocc.info
@@ -0,0 +1,10 @@
+PRGNAM="cosmocc"
+VERSION="3.2.4"
+HOMEPAGE="https://github.com/jart/cosmopolitan"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://cosmo.zip/pub/cosmocc/cosmocc-3.2.4.zip"
+MD5SUM_x86_64="77388a5964416aaa65ac60e400e3569a"
+REQUIRES=""
+MAINTAINER="Juan M. Lasca"
+EMAIL="juanmlasca@gmail.com"
diff --git a/development/cosmocc/scripts/register_ape.sh b/development/cosmocc/scripts/register_ape.sh
new file mode 100644
index 000000000000..d78f007d539a
--- /dev/null
+++ b/development/cosmocc/scripts/register_ape.sh
@@ -0,0 +1,5 @@
+
+# register APE loader
+echo ':APE:M::MZqFpD::/usr/bin/ape:' > /proc/sys/fs/binfmt_misc/register
+echo ':APE-jart:M::jartsr::/usr/bin/ape:' > /proc/sys/fs/binfmt_misc/register
+
diff --git a/development/cosmocc/scripts/unregister_ape.sh b/development/cosmocc/scripts/unregister_ape.sh
new file mode 100644
index 000000000000..ab466355913d
--- /dev/null
+++ b/development/cosmocc/scripts/unregister_ape.sh
@@ -0,0 +1,5 @@
+
+# unregister APE loader
+echo -1 > /proc/sys/fs/binfmt_misc/cli
+echo -1 > /proc/sys/fs/binfmt_misc/status
+
diff --git a/development/cosmocc/slack-desc b/development/cosmocc/slack-desc
new file mode 100644
index 000000000000..447ac7b47fa3
--- /dev/null
+++ b/development/cosmocc/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cosmocc: cosmocc (APE compiler toolchain)
+cosmocc:
+cosmocc: cosmocc is a precompiled version of GCC that produces polyglot
+cosmocc: executables for the x86_64 architecture using the Cosmopolitan libc.
+cosmocc:
+cosmocc: For more information, see:
+cosmocc: https://github.com/jart/cosmopolitan
+cosmocc: https://cosmo.zip/
+cosmocc: https://justine.lol/ape.html
+cosmocc:
+cosmocc: